Index: wsdl/abac.wsdl
===================================================================
--- wsdl/abac.wsdl	(revision 8e54792c966a61d5a0bb3224abd90f5c26fe3540)
+++ wsdl/abac.wsdl	(revision 10a7053bc911e6ce56c439c7fd52ae871d6488c2)
@@ -1,19 +1,19 @@
 <?xml version="1.0"?>
 <definitions name="fedd_abac"
-  targetNamespace="http://www.isi.edu/faber/abac.wsdl"
-  xmlns:tns="http://www.isi.edu/faber/abac.wsdl"
-  xmlns:xsd1="http://www.isi.edu/faber/abac_types"
-  xmlns:xsd2="http://www.isi.edu/faber/fedd_types"
+  targetNamespace="http://www.isi.edu/abac.wsdl"
+  xmlns:tns="http://www.isi.edu/abac.wsdl"
+  xmlns:xsd1="http://www.isi.edu/abac_types"
+  xmlns:xsd2="http://www.isi.edu/fedd_types"
   xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
   xmlns="http://schemas.xmlsoap.org/wsdl/">
 
 
-   <import namespace="http://www.isi.edu/faber/abac_types" 
+   <import namespace="http://www.isi.edu/abac_types" 
 	 location="abac_types.xsd"/>
 
-   <import namespace="http://www.isi.edu/faber/fedd_types" 
+   <import namespace="http://www.isi.edu/fedd_types" 
 	 location="fedd_types.xsd"/>
    <!--Is topdl needed? -->
-   <import namespace="http://www.isi.edu/faber/topdl" 
+   <import namespace="http://www.isi.edu/topdl" 
 	 location="topdl.xsd"/>
   <!--
@@ -153,15 +153,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:NegotiateRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:NegotiateResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="NegotiateFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -171,15 +171,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:CreateContextRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:CreateContextResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="NegotiateFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -189,15 +189,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:AccessRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:AccessResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="NegotiateFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -207,15 +207,15 @@
         <input>
           <soap:body use="literal" parts="tns:CredentialUpdateRequestBody"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
+            namespace="http://www.isi.edu/fedd.wsdl"
             encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
         </input>
         <output>
           <soap:body use="literal" parts="tns:CredentialUpdateResponseBody"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
-            encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
-        </output>
-        <fault name="NegotiateFeddFault">
-          <soap:fault use="literal"  name="tns:FeddFault"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
+            namespace="http://www.isi.edu/fedd.wsdl"
+            encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
+        </output>
+        <fault name="NegotiateFeddFault">
+          <soap:fault use="literal"  name="tns:FeddFault"
+            namespace="http://www.isi.edu/fedd.wsdl"
             encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
         </fault>
@@ -225,15 +225,15 @@
         <input>
           <soap:body use="literal" parts="tns:AddCertificateRequestBody"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
+            namespace="http://www.isi.edu/fedd.wsdl"
             encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
         </input>
         <output>
           <soap:body use="literal" parts="tns:AddCertificateResponseBody"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
-            encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
-        </output>
-        <fault name="NegotiateFeddFault">
-          <soap:fault use="literal"  name="tns:FeddFault"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
+            namespace="http://www.isi.edu/fedd.wsdl"
+            encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
+        </output>
+        <fault name="NegotiateFeddFault">
+          <soap:fault use="literal"  name="tns:FeddFault"
+            namespace="http://www.isi.edu/fedd.wsdl"
             encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
         </fault>
@@ -243,15 +243,15 @@
         <input>
           <soap:body use="literal" parts="tns:RemoveCertificateRequestBody"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
+            namespace="http://www.isi.edu/fedd.wsdl"
             encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
         </input>
         <output>
           <soap:body use="literal" parts="tns:RemoveCertificateResponseBody"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
-            encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
-        </output>
-        <fault name="NegotiateFeddFault">
-          <soap:fault use="literal"  name="tns:FeddFault"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
+            namespace="http://www.isi.edu/fedd.wsdl"
+            encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
+        </output>
+        <fault name="NegotiateFeddFault">
+          <soap:fault use="literal"  name="tns:FeddFault"
+            namespace="http://www.isi.edu/fedd.wsdl"
             encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
         </fault>
@@ -261,15 +261,15 @@
         <input>
           <soap:body use="literal" parts="tns:DiscoveryRequestBody"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
+            namespace="http://www.isi.edu/fedd.wsdl"
             encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
         </input>
         <output>
           <soap:body use="literal" parts="tns:DiscoveryResponseBody"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
-            encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
-        </output>
-        <fault name="NegotiateFeddFault">
-          <soap:fault use="literal"  name="tns:FeddFault"
-            namespace="http://www.isi.edu/faber/fedd.wsdl"
+            namespace="http://www.isi.edu/fedd.wsdl"
+            encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
+        </output>
+        <fault name="NegotiateFeddFault">
+          <soap:fault use="literal"  name="tns:FeddFault"
+            namespace="http://www.isi.edu/fedd.wsdl"
             encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
         </fault>
@@ -283,5 +283,5 @@
       </documentation>
       <port name="feddABACPort" binding="tns:feddABACBinding">
-	<soap:address location="http://www.isi.edu/faber/fedd"/>
+	<soap:address location="http://www.isi.edu/fedd"/>
       </port>
     </service>
Index: wsdl/abac_types.xsd
===================================================================
--- wsdl/abac_types.xsd	(revision 8e54792c966a61d5a0bb3224abd90f5c26fe3540)
+++ wsdl/abac_types.xsd	(revision 10a7053bc911e6ce56c439c7fd52ae871d6488c2)
@@ -1,7 +1,7 @@
 <?xml version="1.0"?>
-<xsd:schema targetNamespace="http://www.isi.edu/faber/abac_types"
+<xsd:schema targetNamespace="http://www.isi.edu/abac_types"
   xmlns:xsd="http://www.w3.org/2001/XMLSchema"
-  xmlns:tns="http://www.isi.edu/faber/abac_types"
-  xmlns:xsd1="http://www.isi.edu/faber/fedd_types"
+  xmlns:tns="http://www.isi.edu/abac_types"
+  xmlns:xsd1="http://www.isi.edu/fedd_types"
   xmlns="http://www.w3.org/2000/10/XMLSchema">
 
Index: wsdl/fedd.wsdl
===================================================================
--- wsdl/fedd.wsdl	(revision 8e54792c966a61d5a0bb3224abd90f5c26fe3540)
+++ wsdl/fedd.wsdl	(revision 10a7053bc911e6ce56c439c7fd52ae871d6488c2)
@@ -1,15 +1,15 @@
 <?xml version="1.0"?>
 <definitions name="fedd"
-  targetNamespace="http://www.isi.edu/faber/fedd.wsdl"
-  xmlns:tns="http://www.isi.edu/faber/fedd.wsdl"
-  xmlns:xsd1="http://www.isi.edu/faber/fedd_types"
-  xmlns:topdl="http://www.isi.edu/faber/topdl"
+  targetNamespace="http://www.isi.edu/fedd.wsdl"
+  xmlns:tns="http://www.isi.edu/fedd.wsdl"
+  xmlns:xsd1="http://www.isi.edu/fedd_types"
+  xmlns:topdl="http://www.isi.edu/topdl"
   xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
   xmlns="http://schemas.xmlsoap.org/wsdl/">
 
-   <import namespace="http://www.isi.edu/faber/fedd_types" 
+   <import namespace="http://www.isi.edu/fedd_types" 
      location="fedd_types.xsd"/>
 
-   <import namespace="http://www.isi.edu/faber/topdl" 
+   <import namespace="http://www.isi.edu/topdl" 
          location="topdl.xsd"/>
   <!--
@@ -275,15 +275,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:RequestAccessRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:RequestAccessResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="RequestAccessFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -296,15 +296,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:ReleaseAccessRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:ReleaseAccessResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="ReleaseAccessFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -317,15 +317,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:NewRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:NewResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="NewFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -338,15 +338,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:CreateRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:CreateResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="CreateFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -359,15 +359,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:VtopoRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:VtopoResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="VtopoFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -381,15 +381,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:VisRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:VisResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="VisFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -402,15 +402,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:InfoRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:InfoResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="InfoFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -423,15 +423,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:MultiInfoRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:MultiInfoResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="MultiInfoFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -444,15 +444,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:TerminateRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:TerminateResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="TerminateFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -465,15 +465,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:StartSegmentRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:StartSegmentResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="StartSegmentFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -486,15 +486,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:TerminateSegmentRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:TerminateSegmentResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="TerminateSegmentFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -507,15 +507,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:SetValueRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:SetValueResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="SetValueFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -528,15 +528,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:GetValueRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:GetValueResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="GetValueFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -549,5 +549,5 @@
       </documentation>
       <port name="feddPort" binding="tns:feddBinding">
-	<soap:address location="http://www.isi.edu/faber/fedd"/>
+	<soap:address location="http://www.isi.edu/fedd"/>
       </port>
     </service>
Index: wsdl/fedd_internal.wsdl
===================================================================
--- wsdl/fedd_internal.wsdl	(revision 8e54792c966a61d5a0bb3224abd90f5c26fe3540)
+++ wsdl/fedd_internal.wsdl	(revision 10a7053bc911e6ce56c439c7fd52ae871d6488c2)
@@ -1,14 +1,14 @@
 <?xml version="1.0"?>
 <definitions name="fedd_internal"
-  targetNamespace="http://www.isi.edu/faber/fedd_internal.wsdl"
-  xmlns:tns="http://www.isi.edu/faber/fedd_internal.wsdl"
-  xmlns:xsd1="http://www.isi.edu/faber/fedd_types"
+  targetNamespace="http://www.isi.edu/fedd_internal.wsdl"
+  xmlns:tns="http://www.isi.edu/fedd_internal.wsdl"
+  xmlns:xsd1="http://www.isi.edu/fedd_types"
   xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
   xmlns="http://schemas.xmlsoap.org/wsdl/">
   
-  <import namespace="http://www.isi.edu/faber/fedd_types" 
+  <import namespace="http://www.isi.edu/fedd_types" 
     location="fedd_types.xsd"/>
 
-   <import namespace="http://www.isi.edu/faber/topdl" 
+   <import namespace="http://www.isi.edu/topdl" 
          location="topdl.xsd"/>
 
@@ -113,15 +113,15 @@
 	<input>
 	  <soap:body use="encoded" parts="tns:AllocateProjectRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="encoded" parts="tns:AllocateProjectResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="AllocateFault">
 	  <soap:fault use="encoded"  name="tns:AllocateProjectFault"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -134,15 +134,15 @@
 	<input>
 	  <soap:body use="encoded" parts="tns:StaticProjectRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="encoded" parts="tns:StaticProjectResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="StaticFault">
 	  <soap:fault use="encoded"  name="tns:StaticProjectFault"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -155,15 +155,15 @@
 	<input>
 	  <soap:body use="encoded" parts="tns:ReleaseProjectRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="encoded" parts="tns:ReleaseProjectResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="ReleaseFault">
 	  <soap:fault use="encoded"  name="tns:ReleaseProjectFault"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -176,15 +176,15 @@
 	<input>
 	  <soap:body use="encoded" parts="tns:Ns2TopdlRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="encoded" parts="tns:Ns2TopdlResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="Ns2TopdlFault">
 	  <soap:fault use="encoded"  name="tns:Ns2TopdlFault"
-	    namespace="http://www.isi.edu/faber/fedd_internal.wsdl"
+	    namespace="http://www.isi.edu/fedd_internal.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -197,5 +197,5 @@
       </documentation>
       <port name="fedd_internal_port" binding="tns:feddInternalBinding">
-	<soap:address location="http://www.isi.edu/faber/fedd_internal"/>
+	<soap:address location="http://www.isi.edu/fedd_internal"/>
       </port>
     </service>
Index: wsdl/fedd_types.xsd
===================================================================
--- wsdl/fedd_types.xsd	(revision 8e54792c966a61d5a0bb3224abd90f5c26fe3540)
+++ wsdl/fedd_types.xsd	(revision 10a7053bc911e6ce56c439c7fd52ae871d6488c2)
@@ -1,6 +1,6 @@
 <?xml version="1.0"?>
-<xsd:schema targetNamespace="http://www.isi.edu/faber/fedd_types"
-  xmlns:tns="http://www.isi.edu/faber/fedd_types"
-  xmlns:topdl="http://www.isi.edu/faber/topdl"
+<xsd:schema targetNamespace="http://www.isi.edu/fedd_types"
+  xmlns:tns="http://www.isi.edu/fedd_types"
+  xmlns:topdl="http://www.isi.edu/topdl"
   xmlns:xsd="http://www.w3.org/2001/XMLSchema"
   xmlns="http://www.w3.org/2000/10/XMLSchema">
Index: wsdl/topdl.xsd
===================================================================
--- wsdl/topdl.xsd	(revision 8e54792c966a61d5a0bb3224abd90f5c26fe3540)
+++ wsdl/topdl.xsd	(revision 10a7053bc911e6ce56c439c7fd52ae871d6488c2)
@@ -1,6 +1,6 @@
 <?xml version="1.0"?>
-<xsd:schema targetNamespace="http://www.isi.edu/faber/topdl"
-  xmlns:tns="http://www.isi.edu/faber/topdl"
-  xmlns:fns="http://www.isi.edu/faber/fedd_types"
+<xsd:schema targetNamespace="http://www.isi.edu/topdl"
+  xmlns:tns="http://www.isi.edu/topdl"
+  xmlns:fns="http://www.isi.edu/fedd_types"
   xmlns:xsd="http://www.w3.org/2001/XMLSchema"
   xmlns="http://www.w3.org/2000/10/XMLSchema">