Index: fedd/federation/fedd_abac_services.py
===================================================================
--- fedd/federation/fedd_abac_services.py	(revision 19a3e06e1d4620767d0d9a8593b731bb3bfd6ec5)
+++ fedd/federation/fedd_abac_services.py	(revision 19a3e06e1d4620767d0d9a8593b731bb3bfd6ec5)
@@ -0,0 +1,116 @@
+################################################## 
+# fedd_abac_services.py 
+# generated by ZSI.generate.wsdl2python
+##################################################
+
+
+from fedd_abac_services_types import *
+import urlparse, types
+from ZSI.TCcompound import ComplexType, Struct
+from ZSI import client
+import ZSI
+from ZSI.generate.pyclass import pyclass_type
+
+# Locator
+class feddABACServiceLocator:
+    feddABACPortType_address = "http://www.isi.edu/faber/fedd"
+    def getfeddABACPortTypeAddress(self):
+        return feddABACServiceLocator.feddABACPortType_address
+    def getfeddABACPortType(self, url=None, **kw):
+        return feddABACBindingSOAP(url or feddABACServiceLocator.feddABACPortType_address, **kw)
+
+# Methods
+class feddABACBindingSOAP:
+    def __init__(self, url, **kw):
+        kw.setdefault("readerclass", None)
+        kw.setdefault("writerclass", None)
+        # no resource properties
+        self.binding = client.Binding(url=url, **kw)
+        # no ws-addressing
+
+    # op: Negotiate
+    def Negotiate(self, request):
+        if isinstance(request, NegotiateRequestMessage) is False:
+            raise TypeError, "%s incorrect request type" % (request.__class__)
+        kw = {}
+        # no input wsaction
+        self.binding.Send(None, None, request, soapaction="Negotiate", **kw)
+        # no output wsaction
+        response = self.binding.Receive(NegotiateResponseMessage.typecode)
+        return response
+
+    # op: CreateContext
+    def CreateContext(self, request):
+        if isinstance(request, CreateContextRequestMessage) is False:
+            raise TypeError, "%s incorrect request type" % (request.__class__)
+        kw = {}
+        # no input wsaction
+        self.binding.Send(None, None, request, soapaction="CreateContext", **kw)
+        # no output wsaction
+        response = self.binding.Receive(CreateContextResponseMessage.typecode)
+        return response
+
+    # op: AccessRequest
+    def AccessRequest(self, request):
+        if isinstance(request, AccessRequestMessage) is False:
+            raise TypeError, "%s incorrect request type" % (request.__class__)
+        kw = {}
+        # no input wsaction
+        self.binding.Send(None, None, request, soapaction="AccessReqest", **kw)
+        # no output wsaction
+        response = self.binding.Receive(AccessResponseMessage.typecode)
+        return response
+
+_NegotiateRequestMessageTypecode = Struct(pname=("http://www.isi.edu/faber/fedd.wsdl","Negotiate"), ofwhat=[ns0.negotiationType_Def(pname="NegotiateRequestBody", aname="_NegotiateRequestBody", typed=False, encoded=None, minOccurs=1, maxOccurs=1, nillable=True)], pyclass=None, encoded="http://www.isi.edu/faber/fedd.wsdl")
+class NegotiateRequestMessage:
+    typecode = _NegotiateRequestMessageTypecode
+    __metaclass__ = pyclass_type
+    def __init__(self):
+        self._NegotiateRequestBody = None
+        return
+NegotiateRequestMessage.typecode.pyclass = NegotiateRequestMessage
+
+_NegotiateResponseMessageTypecode = Struct(pname=("http://www.isi.edu/faber/fedd.wsdl","NegotiateResponse"), ofwhat=[ns0.negotiationType_Def(pname="NegotiateResponseBody", aname="_NegotiateResponseBody", typed=False, encoded=None, minOccurs=1, maxOccurs=1, nillable=True)], pyclass=None, encoded="http://www.isi.edu/faber/fedd.wsdl")
+class NegotiateResponseMessage:
+    typecode = _NegotiateResponseMessageTypecode
+    __metaclass__ = pyclass_type
+    def __init__(self):
+        self._NegotiateResponseBody = None
+        return
+NegotiateResponseMessage.typecode.pyclass = NegotiateResponseMessage
+
+_CreateContextRequestMessageTypecode = Struct(pname=("http://www.isi.edu/faber/fedd.wsdl","CreateContext"), ofwhat=[ns0.contextInfo_Def(pname="ContextIn", aname="_ContextIn", typed=False, encoded=None, minOccurs=1, maxOccurs=1, nillable=True)], pyclass=None, encoded="http://www.isi.edu/faber/fedd.wsdl")
+class CreateContextRequestMessage:
+    typecode = _CreateContextRequestMessageTypecode
+    __metaclass__ = pyclass_type
+    def __init__(self):
+        self._ContextIn = None
+        return
+CreateContextRequestMessage.typecode.pyclass = CreateContextRequestMessage
+
+_CreateContextResponseMessageTypecode = Struct(pname=("http://www.isi.edu/faber/fedd.wsdl","CreateContextResponse"), ofwhat=[ns0.contextInfo_Def(pname="ContextOut", aname="_ContextOut", typed=False, encoded=None, minOccurs=1, maxOccurs=1, nillable=True)], pyclass=None, encoded="http://www.isi.edu/faber/fedd.wsdl")
+class CreateContextResponseMessage:
+    typecode = _CreateContextResponseMessageTypecode
+    __metaclass__ = pyclass_type
+    def __init__(self):
+        self._ContextOut = None
+        return
+CreateContextResponseMessage.typecode.pyclass = CreateContextResponseMessage
+
+_AccessRequestMessageTypecode = Struct(pname=("http://www.isi.edu/faber/fedd.wsdl","AccessRequest"), ofwhat=[ns0.negotiationRequest_Def(pname="NegotiationContext", aname="_NegotiationContext", typed=False, encoded=None, minOccurs=1, maxOccurs=1, nillable=True)], pyclass=None, encoded="http://www.isi.edu/faber/fedd.wsdl")
+class AccessRequestMessage:
+    typecode = _AccessRequestMessageTypecode
+    __metaclass__ = pyclass_type
+    def __init__(self):
+        self._NegotiationContext = None
+        return
+AccessRequestMessage.typecode.pyclass = AccessRequestMessage
+
+_AccessResponseMessageTypecode = Struct(pname=("http://www.isi.edu/faber/fedd.wsdl","AccessRequestResponse"), ofwhat=[ns0.negotiationResult_Def(pname="NegotiationResult", aname="_NegotiationResult", typed=False, encoded=None, minOccurs=1, maxOccurs=1, nillable=True)], pyclass=None, encoded="http://www.isi.edu/faber/fedd.wsdl")
+class AccessResponseMessage:
+    typecode = _AccessResponseMessageTypecode
+    __metaclass__ = pyclass_type
+    def __init__(self):
+        self._NegotiationResult = None
+        return
+AccessResponseMessage.typecode.pyclass = AccessResponseMessage