Index: fedd/federation/access.py
===================================================================
--- fedd/federation/access.py	(revision 725c55dbbc695aca2d5a5fd8a55113b262182405)
+++ fedd/federation/access.py	(revision 027b87bcf2d08c18d5e45e080400fb93231b956d)
@@ -16,5 +16,4 @@
 from util import *
 from allocate_project import allocate_project_local, allocate_project_remote
-from access_project import access_project
 from fedid import fedid, generate_fedid
 from authorizer import authorizer
Index: fedd/federation/access_project.py
===================================================================
--- fedd/federation/access_project.py	(revision 725c55dbbc695aca2d5a5fd8a55113b262182405)
+++ 	(revision )
@@ -1,20 +1,0 @@
-#!/usr/local/bin/python
-
-class access_project:
-    """
-    A project description used to grant access to this testbed.
-
-    The description includes a name and a list of node types to which the
-    project will be granted access.
-    """
-    def __init__(self, name, nt):
-	self.name = name
-	self.node_types = list(nt)
-
-    def __repr__(self):
-	if len(self.node_types) > 0:
-	    return "access_proj('%s', ['%s'])" % \
-		    (self.name, str("','").join(self.node_types))
-	else:
-	    return "access_proj('%s', [])" % self.name
-
Index: fedd/federation/deter_internal_access.py
===================================================================
--- fedd/federation/deter_internal_access.py	(revision 725c55dbbc695aca2d5a5fd8a55113b262182405)
+++ fedd/federation/deter_internal_access.py	(revision 027b87bcf2d08c18d5e45e080400fb93231b956d)
@@ -14,5 +14,4 @@
 from util import *
 from allocate_project import allocate_project_local, allocate_project_remote
-from access_project import access_project
 from fedid import fedid, generate_fedid
 from authorizer import authorizer
Index: fedd/federation/dragon_access.py
===================================================================
--- fedd/federation/dragon_access.py	(revision 725c55dbbc695aca2d5a5fd8a55113b262182405)
+++ fedd/federation/dragon_access.py	(revision 027b87bcf2d08c18d5e45e080400fb93231b956d)
@@ -15,5 +15,4 @@
 from util import *
 from allocate_project import allocate_project_local, allocate_project_remote
-from access_project import access_project
 from fedid import fedid, generate_fedid
 from authorizer import authorizer
Index: fedd/federation/emulab_access.py
===================================================================
--- fedd/federation/emulab_access.py	(revision 725c55dbbc695aca2d5a5fd8a55113b262182405)
+++ fedd/federation/emulab_access.py	(revision 027b87bcf2d08c18d5e45e080400fb93231b956d)
@@ -19,5 +19,4 @@
 from util import *
 from allocate_project import allocate_project_local, allocate_project_remote
-from access_project import access_project
 from fedid import fedid, generate_fedid
 from authorizer import authorizer, abac_authorizer
@@ -208,8 +207,7 @@
     def make_access_project(str):
 	"""
-	Convert a string of the form (id[:resources:resouces], id, id) into an
-	access_project.  This is called by read_access to convert to local
-	attributes.  It returns a tuple of the form (project, user, user) where
-	users may be names or fedids.
+	Convert a string of the form (id[:resources:resouces], id, id) into a
+	tuple of the form (project, user, user) where users may be names or
+	fedids.  The resources strings are obsolete and ignored.
 	"""
         def parse_name(n):
@@ -227,5 +225,5 @@
 		del first[0]
 		first[0] = fedid(hexstr=first[0])
-	    names[0] = access_project(first[0], first[1:])
+	    names[0] = first[0]
 
 	    for i in range(1,2):
@@ -249,6 +247,5 @@
 	    # The slice takes the parens off the string.
 	    proj, user = str[1:-1].split(',')
-	    return (access_project(proj.strip(), []), 
-		    user.strip(), user.strip())
+	    return (proj.strip(), user.strip(), user.strip())
 	else:
 	    raise self.parse_error(
@@ -270,5 +267,5 @@
         """
         # Return values
-        rp = access_project(None, ())
+        rp = None
         ru = None
         # This maps a valid user to the Emulab projects and users to use
@@ -285,17 +282,16 @@
         dyn_service_user = False
 
-        if found[0].name == "<same>":
+        if found[0] == "<same>":
             if project != None:
-                rp.name = project
+                rp = project
             else : 
                 raise service_error(\
                         service_error.server_config,
                         "Project matched <same> when no project given")
-        elif found[0].name == "<dynamic>":
-            rp.name = None
+        elif found[0] == "<dynamic>":
+            rp = None
             dyn_proj = True
         else:
-            rp.name = found[0].name
-        rp.node_types = found[0].node_types;
+            rp = found[0]
 
         if found[1] == "<same>":
@@ -503,16 +499,14 @@
 	ap = None
 
-	print "%s %s %s" % (found, dyn, owners)
-
 	# if this includes a project export request and the exported
 	# project is not the access project, access denied.
 	if 'service' in req:
 	    ep = get_export_project(req['service'])
-	    if ep and ep != found[0].name:
+	    if ep and ep != found[0]:
 		raise service_error(service_error.access,
 			"Cannot export %s" % ep)
 
 	if self.ssh_pubkey_file:
-	    ap = self.do_project_allocation(dyn[1], found[0].name, found[1])
+	    ap = self.do_project_allocation(dyn[1], found[0], found[1])
 	else:
 	    raise service_error(service_error.internal, 
Index: fedd/federation/protogeni_access.py
===================================================================
--- fedd/federation/protogeni_access.py	(revision 725c55dbbc695aca2d5a5fd8a55113b262182405)
+++ fedd/federation/protogeni_access.py	(revision 027b87bcf2d08c18d5e45e080400fb93231b956d)
@@ -17,5 +17,4 @@
 
 from util import *
-from access_project import access_project
 from fedid import fedid, generate_fedid
 from authorizer import authorizer